package cz.muni.fi.pb162.sports;


/**
 * Interface for a judge points counters.
 * 
 * @author Radek Oslejsek &lt;oslejsek@fi.muni.cz&gt;
 * @version 2007-10-02
 */

public interface JudgePoints
{
    /**
     * Nastavi body pridelene porotou.
     * 
     * @param points body pridelene porotou
     * @return false jestlize jsou body mensi nez dosavadni maximalni bodovy zisk
     *         true jinak
     */
    boolean setPoints(double points);
    
    /**
     * Vrati nejvetsi bodovy zisk.
     * 
     * @return nejvetsi bodovy zisk
     */
    double getMaxPoints();
}
