package cz.muni.fi.pb162.sports;

import junit.framework.TestCase;

/**
 * The test class SportsTest.
 *
 * @author  (your name)
 * @version (a version number or a date)
 */
public class SportsTest extends TestCase
{
    /**
     * Default constructor for test class SportsTest
     */
    public SportsTest()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    protected void setUp()
    {
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    protected void tearDown()
    {
    }
    
    private void length(String prefix, Length lj, Length ljc) {
        assertTrue("Spatna implicitni namerena delka v " + prefix, lj.getLongestAttempt() <= 0.0);
        assertTrue(prefix+".setLength() vraci false pri ukladani nejdelsiho pokusu", lj.setLength(100.0));
        assertEquals("Chybne ulozeni nejdelsiho pokusu metodou "+prefix+".setLength()", lj.getLongestAttempt(), 100.0);
        assertFalse(prefix+".setLength() vraci true pri ukladani kratsiho pokusu", lj.setLength(50.0));
        assertEquals("Chybne ulozeni kratsiho pokusu metodou "+prefix+".setLength()", lj.getLongestAttempt(), 100.0);
        assertTrue(prefix+".setLength() vraci false pri opetovnem ukladani nejdelsiho pokusu", lj.setLength(100));
        
        assertTrue(prefix+".setLengthInMeters() vraci false pri ukladani nejdelsiho pokusu", ljc.setLengthInMeters(0.1));
        assertEquals("Chybne ulozeni nejdelsiho pokusu metodou "+prefix+".setLengthInMeters()", ljc.getLongestAttempt(), 10.0);
        assertFalse(prefix+".setLengthInMeters() vraci true pri ukladani kratsiho pokusu", ljc.setLengthInMeters(0.05));
        assertEquals("Chybne ulozeni kratsiho pokusu metodou "+prefix+".setLengthInMeters()", ljc.getLongestAttempt(), 10.0);
        assertTrue(prefix+".setLengthInMeters() vraci false pri opetovnem ukladani nejdelsiho pokusu", ljc.setLengthInMeters(0.1));
        
        assertTrue("Chyba pri ulkadani v centimetrech a pak v metrech", lj.setLengthInMeters(1.0));
    }
    
    public void testLength()
    {
        length("LongJump", new LongJump(), new LongJump());
    }
    
    public void testJudgePoints()
    {
        length("SkiJump", new SkiJump(), new SkiJump());
        
        JudgePoints jp = new SkiJump();
        assertTrue("Spatna implicitni pocet bodu ve SkiJump", jp.getMaxPoints() <= 0.0);
        assertTrue("SkiJump.setPoints() vraci false pri ukladani max. bodu", jp.setPoints(0.8));
        assertEquals("Chybne ulozeni max. bodu metodou SkiJump.setPoints()", jp.getMaxPoints(), 0.8);
        assertFalse("SkiJump.setPoints() vraci true pri ukladani kratsiho pokusu", jp.setPoints(0.5));
        assertEquals("Chybne ulozeni mensich bodu metodou SkiJump.setPoints()", jp.getMaxPoints(), 0.8);
        assertTrue("SkiJump.setPoints() vraci false pri opetovnem ukladani max. bodu", jp.setPoints(0.8));
    }
}
